!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module FileSet
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: fileset.f90,v 1.3 2005/10/04 02:38:01 kitamo Exp $ 
!   * Tag Name: $Name: arare3-20051019 $
!   * Change History: 
!
!== Overview 
!
!NAMELIST ե̾ꤷ, deepconv/arare νϥե
!NAMELIST 뤿Υ⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
                                                                 !=end
module fileset
  !== ۤηػ
  implicit none

  !== save °
  save
                                                                 !=begin
  !== Public Data
  character(80) :: cfgfile    = "arare.conf"  !ե

  !== Public Interface
  character(80) :: RegFile            ! nc ե(ʪΰ)
  character(80) :: DimFile            ! nc ե(׻ΰ)
  character(80) :: ReStartFile        !ѥꥹȥե
  character(80) :: NewReStartFile     !ѥꥹȥե
  character(80) :: RandomFile         !ե

                                                                 !=end
contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !NAMELIST ե̾դ륿, ϥե̾. 
  !
  subroutine fileset_init
    !=== Dependency
    use dc_trace,      only: BeginSub, EndSub 
    use dc_message,    only: MessageNotify
                                                                 !=end
    !=== ۤηػ
    implicit none

    !=== Work
    character(80) :: flag
                                                                 !=begin
    !=== NAMELIST
    NAMELIST /fileset/ flag, ReStartFile, RandomFile
                                                                 !=end

    call BeginSub("fileset_init", &
&                 fmt="%c",       &
&                 c1="Initialize file names. ")

    open (10, FILE=cfgfile)
    read(10, NML=fileset)
    close(10)

    RegFile = "arare-"     // trim(flag) // ".nc"
    DimFile = "arare_dim-" // trim(flag) // ".nc"
    NewReStartFile = "arare-" // trim(flag) // "-restart.nc"


    !=== ǧ
    call MessageNotify("Message", "fileset_init", &
&                       "Configuration file is %c1", c1=cfgfile)

    call MessageNotify("Message", "fileset_init", &
&                       "Physical Region Date File is %c1", c1=RegFile)

    call MessageNotify("Message", "fileset_init", &
&                       "All Region Date File is %c1", c1=DimFile)

    call MessageNotify("Message", "fileset_init", &
&                       "Outpur Restart File is %c1", c1=ReStartFile)

    call EndSub("fileset_init")
    
  end subroutine fileset_init
  
end module fileset
